﻿sep=,
<#-- BPR Report of confidentiality requests main template file -->
<#-- Include utilities for the list of confidentiality flag identifiers -->
<#include "bpr_conf_requests_csv_utilities.ftl" />
<#-- Import common macros and functions -->
<#import "../../application/docbook+xml/macros_common.ftl" as com>
<#assign orient="land"/>
<#assign locale = "en" />
<#assign mixture = com.getReportSubject(rootDocument) />
<#-- TODO -->
<#-- Stop if the root document is not mixture -->
<#if false>
	<#stop "BPR Confidentiality Claims template expects a mixture/product as root document. The root document is not a mixture/product!" />
</#if>
<#-- Print the headears for each column -->
No.,Section in IUCLID,Type,Item,Name,Section UUID,Justification,Accept/Do Not Accept confidentiality claim,Decision based on dossier assessment or additional information or both of these two sources,ECHA's assessment remarks
<#compress>
				
	<#-- Mixture/Product dataset specific confidentiality flags -->
	<#list productConfFlagIdentifierList as flagIdItem>
		<#assign documentList = iuclid.getSectionDocumentsForParentKey(mixture.documentKey, flagIdItem.docType, flagIdItem.docSubType) />
		<#list documentList as document>			
			<@tableRowForConfidentialityFlag document flagIdItem "Product" document document.name document.documentKey.uuid/>			
		</#list>
	</#list>
	
	<#-- Active Substance dataset specific confidentiality flags -->
	<#assign activeSubstanceList = getActiveSubstanceList(mixture) />	
	<#list activeSubstanceList as substance>
		<#-- Active Substance dataset confidentiality flags -->
		<#list substanceConfFlagIdentifierList as flagItemId>				
			<#assign documentList = iuclid.getSectionDocumentsForParentKey(substance.documentKey, flagItemId.docType, flagItemId.docSubType) />
			<#list documentList as document>											
				<@tableRowForConfidentialityFlag document flagItemId "Active Substance" document document.name document.documentKey.uuid />
			</#list>
		</#list>
			
		<#-- Active Substance section 1.3 specific confidentiality flag if AS is SDS hazardous -->	
		<#if isHazardCategory(substance)>		
			<#assign documentList = iuclid.getSectionDocumentsForParentKey(substance.documentKey, "FLEXIBLE_RECORD", "Suppliers") />
			<#list documentList as document>														
				<@tableRowForConfidentialityFlag document substanceActiveSubstanceIdentifierFlagId "Active Substance" document document.name document.documentKey.uuid />											
			</#list>
		</#if>
		
		<#-- Active Substance specific confidentiality flags for Subsance_section and SubstanceComposition -->					
		<#assign document = substance />					
			<#if document?has_content>
				<#list document.OtherNames as otherIdentifierItem>
					<@tableRowForConfidentialityFlag otherIdentifierItem substanceOtherIdentifierFlagId "Active Substance" document document.name document.documentKey.uuid />
				</#list>
			</#if>		
		
		<#assign documentList = iuclid.getSectionDocumentsForParentKey(substance.documentKey, "FLEXIBLE_RECORD", "SubstanceComposition") />					
		<#list documentList as document>
			<#if isAdditivesImpuritiesPopulated(document)>
			
				<#if isRelevantForClassification(document)>
					<@tableRowForConfidentialityFlag document substanceCompositionDegreeOfPurityConfFlagId "Active Substance" document document.name document.documentKey.uuid/>
				</#if>
				
				<#list document.Impurities.Impurities as impurityItem>
				<#assign cb = impurityItem.RelevantForClassificationLabeling />
					<#if cb>
					<@tableRowForConfidentialityFlag impurityItem substanceCompositionImpuritiesConfFlagId "Active Substance" document document.name document.documentKey.uuid />
					</#if>
				</#list>
				
				<#list document.Additives.Additives as additiveItem>
				<#assign cb = additiveItem.RelevantForClassificationLabeling />
					<#if cb>
					<@tableRowForConfidentialityFlag additiveItem substanceCompositionAdditivesConfFlagId "Active Substance" document document.name document.documentKey.uuid />
					</#if>
				</#list>						
			</#if>
		</#list>								
	</#list>	


	<#-- Other Substance dataset specific confidentiality flags -->					
	<#assign otherSubstanceList = getOtherSubstanceList(mixture) />
	
	<#list otherSubstanceList as substance>
	
		<#-- Other Substance confidentiality flags -->
		
		<#list substanceConfFlagIdentifierList as flagItemId>				
			<#assign documentList = iuclid.getSectionDocumentsForParentKey(substance.documentKey, flagItemId.docType, flagItemId.docSubType) />
			<#list documentList as document>
				
				<@tableRowForConfidentialityFlag document flagItemId "Other Substance" document document.name document.documentKey.uuid />
				
			</#list>
		</#list>
			
		<#-- Other Substance specific confidentiality flags -->					
		<#assign document = substance />					
			<#if document?has_content>
				<#list document.OtherNames as otherIdentifierItem>
					<#if document.documentType=="MIXTURE">
						<@tableRowForConfidentialityFlag otherIdentifierItem mixtureOtherIdentifierFlagId "Other Substance" document document.name document.documentKey.uuid />
					<#else>
						<@tableRowForConfidentialityFlag otherIdentifierItem substanceOtherIdentifierFlagId "Other Substance" document document.name document.documentKey.uuid />
					</#if>					
				</#list>
			</#if>
											
		<#assign documentList = iuclid.getSectionDocumentsForParentKey(substance.documentKey, "FLEXIBLE_RECORD", "SubstanceComposition") />
		<#list documentList as document>
			<#if isAdditivesImpuritiesPopulated(document)>
		
				<#if isRelevantForClassification(document)>
				<@tableRowForConfidentialityFlag document substanceCompositionDegreeOfPurityConfFlagId "Other Substance" document document.name document.documentKey.uuid />
				</#if>
				
				<#list document.Impurities.Impurities as impurityItem>
				<#assign cb = impurityItem.RelevantForClassificationLabeling />
					<#if cb>
						<@tableRowForConfidentialityFlag impurityItem substanceCompositionImpuritiesConfFlagId "Other Substance" document document.name document.documentKey.uuid />
					</#if>
				</#list>
				
				<#list document.Additives.Additives as additiveItem>
				<#assign cb = additiveItem.RelevantForClassificationLabeling />
					<#if cb>
						<@tableRowForConfidentialityFlag additiveItem substanceCompositionAdditivesConfFlagId "Other Substance" document document.name document.documentKey.uuid />
					</#if>
				</#list>
			</#if>
		</#list>
		
		<#assign documentList = iuclid.getSectionDocumentsForParentKey(substance.documentKey, "FLEXIBLE_RECORD", "Suppliers") />
		<#list documentList as document>
			<@tableRowForConfidentialityFlag document substanceActiveSubstanceIdentifierFlagId "Other Substance" document document.name document.documentKey.uuid/>										
		</#list>
		
	</#list>
</#compress>
				
<#-- Macros and functions -->
<#macro tableRowForConfidentialityFlag item flagIdentifier typeText="" document="" documentName="" documentUUID="">
<#if item?has_content && flagIdentifier?has_content>
<#if isDataProtectionAvailable(item, flagIdentifier)>
<#assign docUrl=iuclid.webUrl.documentView(document.documentKey) />
,<@com.text flagIdentifier.sectionNr />,<@com.text typeText />,<@com.text flagIdentifier.sectionName />,<#if documentName?has_content>${documentName?replace(",","")}<#else/>${document.name?replace(",","")}</#if>,<#if documentUUID?has_content><#if docUrl?has_content>"=HYPERLINK(""${docUrl}"", ""<@com.text documentUUID />"")"<#else>${documentUUID?replace(",","")}</#if><#else><@com.text document.documentKey.uuid /></#if>,<#local justificationPath = "item." + flagIdentifier.confFlagPath + ".justification" /><#local justification = justificationPath?eval /><#if justification?has_content><@compress single_line=true>${justification?replace(",","")}</@compress><#else/>no justification provided</#if>, , ,
</#if>
</#if>
</#macro>

<#compress>
<#function getActiveSubstanceList mixture>
	<#local substanceList = []/>
	<#local compositionList = iuclid.getSectionDocumentsForParentKey(mixture.documentKey, "FLEXIBLE_RECORD", "MixtureComposition") />	
	<#list compositionList as composition>
		<#local componentList = composition.Components.Components/>	
		<#list componentList as component>
			<#if isComponentActiveSubstance(component)>
				<#local substance = iuclid.getDocumentForKey(component.Reference)/>
				<#if !(substance)?has_content>
				<#return [] />
				<#else/>
					<#if substance.documentType=="SUBSTANCE" || substance.documentType=="MIXTURE">
						<#local substanceList = com.addDocumentToSequenceAsUnique(substance, substanceList)/>						
					</#if>
				</#if>
			</#if>			
		</#list>
	</#list>	
	<#return substanceList />
</#function>
</#compress>
<#compress>
<#function isComponentActiveSubstance component>
	<#return component.Function?has_content && com.picklistValueMatchesPhrases(component.Function, ["active substance"]) />
</#function>
</#compress>
<#compress>
<#function getOtherSubstanceList mixture>
	<#local substanceList = []/>
	<#local compositionList = iuclid.getSectionDocumentsForParentKey(mixture.documentKey, "FLEXIBLE_RECORD", "MixtureComposition") />
	<#list compositionList as composition>
		<#local componentList = composition.Components.Components/>
		<#list componentList as component>
			<#if isComponentOtherSubstance(component)>
				<#local substance = iuclid.getDocumentForKey(component.Reference)/>
				<#if !(substance)?has_content>
				<#return [] />
				<#else/>
					<#if substance.documentType=="SUBSTANCE" || substance.documentType=="MIXTURE">
						<#local substanceList = com.addDocumentToSequenceAsUnique(substance, substanceList)/>						
					</#if>
				</#if>
			</#if>
		</#list>
	</#list>	
	<#return substanceList />
</#function>
</#compress>
<#compress>
<#function isComponentOtherSubstance component>
	<#return component.Function?has_content && com.picklistValueMatchesPhrases(component.Function, ["absorbent", "adsorbent", "anticaking agent", "anticoagulant", "booster", "buffer", "coagulant", "coating agent", "colourant", "complexing agent", "conditioner", "controlled release agent", "crystal growth regulator", "dehydrating agent", "denaturant", "drying agent", "dye", "emulsifier", "filler", "flow aid agent", "fragrance", "hardener", "lubricant",
	 "moisturiser", "neutraliser", "odour masking agent", "pH adjuster", "pigment", "perfume", "propellant", "solvent", "stabiliser", "stiffener", "UV absorber", "viscosity modifier", "water repellent", "wetting agent", "other:"]) />
</#function>
</#compress>
<#compress>
<#function isHazardCategory substance>
	<#local hazardCategory = iuclid.getSectionDocumentsForParentKey(substance.documentKey, "FLEXIBLE_RECORD", "Ghs") />	
	<#if !(hazardCategory?has_content)>
		<#return false>
	</#if>
	<#list hazardCategory as category>
			<#if category?has_content>
				<#if category.Classification.PhysicalHazards.Explosives.HazardCategory?has_content || 
				category.Classification.PhysicalHazards.FlammableAerosols.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.OxidisingGases.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.GasesPres.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.FlammableLiquids.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.FlammableSolids.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.SelfReactiveSubstMixt.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.PyrophoricLiquids.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.PyrophoricSolids.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.SelfHeatSubstMixt.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.SubstMixtWater.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.OxidisingLiquids.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.OxidisingSolids.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.OrganicPeroxides.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.CorMetals.HazardCategory?has_content ||
				category.Classification.PhysicalHazards.DesensitizedExplosives.HazardCategory?has_content ||
				category.Classification.HealthHazards.AcuteToxicityOral.HazardCategory?has_content ||
				category.Classification.HealthHazards.AcuteToxicityDermal.HazardCategory?has_content ||
				category.Classification.HealthHazards.AcuteToxicityInhalation.HazardCategory?has_content ||
				category.Classification.HealthHazards.Irritation.HazardCategory?has_content ||
				category.Classification.HealthHazards.EyeIrritation.HazardCategory?has_content ||
				category.Classification.HealthHazards.RespiratorySensitisation.HazardCategory?has_content ||
				category.Classification.HealthHazards.SkinSensitisation.HazardCategory?has_content ||
				category.Classification.HealthHazards.AspirationHazard.HazardCategory?has_content ||
				category.Classification.HealthHazards.ReproductiveToxicity.ReproductiveToxicity.HazardCategory?has_content ||
				category.Classification.HealthHazards.GermCell.GermCell.HazardCategory?has_content ||
				category.Classification.HealthHazards.Carcinogenicity.Carcinogenicity.HazardCategory?has_content ||
				category.Classification.EnvironmentalHazards.AquaticEnvironment.AcuteShortTerm.HazardCategory?has_content ||
				category.Classification.EnvironmentalHazards.AquaticEnvironment.LongTerm.HazardCategory?has_content ||
				category.Classification.EnvironmentalHazards.OzoneLayer.HazardousOzone.HazardCategory?has_content ||
				category.Classification.HealthHazards.ToxicitySingle.Toxicity?has_content ||
				category.Classification.HealthHazards.ToxicityRepeated.Toxicity?has_content>
						
				<#return true>
					
				</#if>
			</#if>
	</#list>
	<#return false>
</#function>

<#function isRelevantForClassification document>
	<#local additives = document.Additives.Additives />
	<#list additives as additivesList>
		<#if additivesList?has_content>
			<#local cb = additivesList.RelevantForClassificationLabeling />
			<#if cb>
				<#return true />
			</#if>
		</#if>
	</#list>
	
	<#local impurities = document.Impurities.Impurities />
	<#list impurities as impuritiesList>
		<#if impuritiesList?has_content>
			<#local cb = impuritiesList.RelevantForClassificationLabeling />
			<#if cb>
				<#return true />
			</#if>
		</#if>
	</#list>
	
		<#return false>
</#function>

<#function isRelevantForClassification document>
	<#local additives = document.Additives.Additives />
	<#list additives as additivesList>
		<#if additivesList?has_content>
			<#local cb = additivesList.RelevantForClassificationLabeling />
			<#if cb>
				<#return true />
			</#if>
		</#if>
	</#list>
	
	<#local impurities = document.Impurities.Impurities />
	<#list impurities as impuritiesList>
		<#if impuritiesList?has_content>
			<#local cb = impuritiesList.RelevantForClassificationLabeling />
			<#if cb>
				<#return true />
			</#if>
		</#if>
	</#list>
	
		<#return false>
</#function>

<#function isAdditivesImpuritiesPopulated document>
	<#local additives = document.Additives.Additives />
	<#if additives?has_content>
		<#return true />
	</#if>
	
	<#local impurities = document.Impurities.Impurities />
	<#if impurities?has_content>
		<#return true />
	</#if>
	
		<#return false>
</#function>
<#function isDataProtectionAvailable document flagIdentifier>

		<#assign confidentialityFlagPath = "document." + flagIdentifier.confFlagPath + ".confidentiality" />
		<#local confidentiality = confidentialityFlagPath?eval />
		
		<#assign justificationPath = "document." + flagIdentifier.confFlagPath + ".justification" />
		<#local justification = justificationPath?eval />
		
		<#assign regulatoryPath = "document." + flagIdentifier.confFlagPath + ".legislations" />
		<#local regulatory = regulatoryPath?eval />
		
		<#if confidentiality?has_content || justification?has_content>
		<#return true />
		<#else/>
			<#if !(confidentiality)?has_content || !(justification)?has_content || regulatory?has_content>
			<#return false />
			</#if>
		</#if>
</#function>
</#compress>
